---
title: CSS Functional Notation
slug: Web/CSS/CSS_Functions
tags:
  - CSS
  - CSS Data Type
  - CSS Function
  - Functional Notation
  - Functions
  - Reference
  - Types
  - data types
---
<div>{{CSSRef}}</div>

<p><strong>CSS functional notation</strong> is a type of <a href="/en-US/docs/Web/CSS/CSS_Values_and_Units">CSS value</a> that can represent more complex data types or invoke special data processing or calculations.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">selector {
  property: functional-notation( [argument]? [, argument]! );
}</pre>

<p>The syntax starts with the <strong>name of the functional notation</strong>, followed by a left parenthesis <code>(</code>. Next up are the notation argument(s), and the function is finished off with a closing parenthesis <code>)</code>.</p>

<p>Functions can take multiple arguments, which are formatted similarly to CSS property values. Whitespace is allowed, but they are optional inside the parentheses. In some functional notations multiple arguments are separated by commas, while others use spaces.</p>

<h2 id="Index">Index</h2>

<p>Functional notation defined by a set of CSS specifications includes the following:</p>

<div class="index">

<h3>A</h3>

<ul>
  <li><a href="/en-US/docs/Web/CSS/abs()">abs()</a> (math) {{Experimental_Inline}}</li>
  <li><a href="/en-US/docs/Web/CSS/acos()">acos()</a> (math) {{Experimental_Inline}}</li>
  <li><a href="/en-US/docs/Web/CSS/font-variant-alternates/annotation()">annotation()</a> (font)</li>
  <li><a href="/en-US/docs/Web/CSS/asin()">asin()</a> (math) {{Experimental_Inline}}</li>
  <li><a href="/en-US/docs/Web/CSS/atan()">atan()</a> (math) {{Experimental_Inline}}</li>
  <li><a href="/en-US/docs/Web/CSS/atan2()">atan2()</a> (math) {{Experimental_Inline}}</li>
  <li><a href="/en-US/docs/Web/CSS/attr()">attr()</a> (math) {{Experimental_Inline}}</li>
</ul>

<h3>B</h3>

<ul>
  <li><a href="/en-US/docs/Web/CSS/filter-function/blur()">blur()</a> (filter)</li>
  <li><a href="/en-US/docs/Web/CSS/filter-function/brightness()">brightness()</a> (filter)</li>
</ul>

<h3>C</h3>

<ul>
	<li><a href="/en-US/docs/Web/CSS/calc()">calc()</a> (math)</li>
	<li><a href="/en-US/docs/Web/CSS/font-variant-alternates/character-variant()">character-variant()</a> (font)</li>
	<li><a href="/en-US/docs/Web/CSS/circle()">circle()</a> (shape)</li>
	<li><a href="/en-US/docs/Web/CSS/clamp()">clamp()</a> (math)</li>
	<li><a href="/en-US/docs/Web/CSS/color()">color()</a> (colors) {{Experimental_Inline}}</li>
	<li><a href="/en-US/docs/Web/CSS/conic-gradient()">conic-gradient()</a></li>
	<li><a href="/en-US/docs/Web/CSS/cos()">cos()</a> (math) {{Experimental_Inline}}</li>
	<li><a href="/en-US/docs/Web/CSS/counter()">counter()</a></li>
	<li><a href="/en-US/docs/Web/CSS/counters()">counters()</a></li>
	<li><a href="/en-US/docs/Web/CSS/filter-function/contrast()">contrast()</a> (filter)</li>
	<li><a href="/en-US/docs/Web/CSS/cross-fade()">cross-fade()</a> {{Experimental_Inline}}</li>
	<li><a href="/en-US/docs/Web/CSS/cubic-bezier()">cubic-bezier()</a></li>
</ul>

<h3>D</h3>

<ul>
	<li><a href="/en-US/docs/Web/CSS/device-cmyk()">device-cmyk()</a> (colors) {{Experimental_Inline}}</li>
	<li><a href="/en-US/docs/Web/CSS/filter-function/drop-shadow()">drop-shadow()</a> (filter)</li>
</ul>

<h3>E</h3>

<ul>
	<li><a href="/en-US/docs/Web/CSS/element()">element()</a> {{Experimental_Inline}}</li>
	<li><a href="/en-US/docs/Web/CSS/env()">env()</a> {{Experimental_Inline}}</li>
	<li><a href="/en-US/docs/Web/CSS/ellipse()">ellipse()</a> (shape)</li>
	<li><a href="/en-US/docs/Web/CSS/exp()">exp()</a> (math) {{Experimental_Inline}}</li>
</ul>

<h3>F</h3>

<ul>
	<li><a href="/en-US/docs/Web/CSS/fit-content()">fit-content()</a></li>
	<li><a href="/en-US/docs/Web/CSS/format()">format()</a></li>
</ul>

<h3>G</h3>

<ul>
	<li><a href="/en-US/docs/Web/CSS/filter-function/grayscale()">grayscale()</a> (filter)</li>
</ul>

<h3>H</h3>

<ul>
	<li><a href="/en-US/docs/Web/CSS/hsl()">hsl()</a> (colors)</li>
	<li><a href="/en-US/docs/Web/CSS/hsla()">hsla()</a> (colors)</li>
	<li><a href="/en-US/docs/Web/CSS/filter-function/hue-rotate()">hue-rotate()</a> (filter)</li>
	<li><a href="/en-US/docs/Web/CSS/hwb()">hwb()</a> (colors) {{Experimental_Inline}}</li>
	<li><a href="/en-US/docs/Web/CSS/hypot()">hypot()</a> (math) {{Experimental_Inline}}</li>
</ul>

<h3>I</h3>

<ul>
	<li><a href="/en-US/docs/Web/CSS/image()">image()</a> {{Experimental_Inline}}</li>
	<li><a href="/en-US/docs/Web/CSS/image-set()">image-set()</a> {{Experimental_Inline}}</li>
	<li><a href="/en-US/docs/Web/CSS/inset()">inset()</a> (shape)</li>
	<li><a href="/en-US/docs/Web/CSS/filter-function/invert()">invert()</a> (filter)</li>
</ul>

<h3>L</h3>

<ul>
	<li><a href="/en-US/docs/Web/CSS/lab()">lab()</a> (colors) {{Experimental_Inline}}</li>
	<li><a href="/en-US/docs/Web/CSS/lch()">lch()</a> (colors) {{Experimental_Inline}}</li>
	<li><a href="/en-US/docs/Web/CSS/leader()">leader()</a></li>
	<li><a href="/en-US/docs/Web/CSS/linear-gradient()">linear-gradient()</a></li>
	<li><a href="/en-US/docs/Web/CSS/local()">local()</a> {{Experimental_Inline}}</li>
	<li><a href="/en-US/docs/Web/CSS/log()">log()</a> (math) {{Experimental_Inline}}</li>
</ul>

<h3>M</h3>

<ul>
	<li><a href="/en-US/docs/Web/CSS/transform-function/matrix()">matrix()</a> (transform)</li>
	<li><a href="/en-US/docs/Web/CSS/transform-function/matrix3d()">matrix3d()</a> (transform)</li>
	<li><a href="/en-US/docs/Web/CSS/max()">max()</a> (math)</li>
	<li><a href="/en-US/docs/Web/CSS/min()">min()</a> (math)</li>
	<li><a href="/en-US/docs/Web/CSS/minmax()">minmax()</a> (math)</li>
	<li><a href="/en-US/docs/Web/CSS/mod()">mod()</a> (math) {{Experimental_Inline}}</li>
</ul>

<h3>O</h3>

<ul>
	<li><a href="/en-US/docs/Web/CSS/filter-function/opacity()">opacity()</a> (filter)</li>
	<li><a href="/en-US/docs/Web/CSS/font-variant-alternates/ornaments()">ornaments()</a> (font)</li>
</ul>

<h3>P</h3>

<ul>
	<li><a href="/en-US/docs/Web/CSS/paint()">paint()</a> {{Experimental_Inline}}</li>
	<li><a href="/en-US/docs/Web/CSS/path()">path()</a> (shape)</li>
	<li><a href="/en-US/docs/Web/CSS/transform-function/perspective()">perspective()</a> (transform)</li>
	<li><a href="/en-US/docs/Web/CSS/polygon()">polygon()</a> (shape)</li>
	<li><a href="/en-US/docs/Web/CSS/pow()">pow()</a> (math) {{Experimental_Inline}}</li>
</ul>

<h3>R</h3>

<ul>
	<li><a href="/en-US/docs/Web/CSS/radial-gradient()">radial-gradient()</a></li>
	<li><a href="/en-US/docs/Web/CSS/rem()">rem()</a> (math) {{Experimental_Inline}}</li>
	<li><a href="/en-US/docs/Web/CSS/repeat()">repeat()</a></li>
	<li><a href="/en-US/docs/Web/CSS/repeating-linear-gradient()">repeating-linear-gradient()</a></li>
	<li><a href="/en-US/docs/Web/CSS/repeating-radial-gradient()">repeating-radial-gradient()</a></li>
	<li><a href="/en-US/docs/Web/CSS/repeating-conic-gradient()">repeating-conic-gradient()</a></li>
	<li><a href="/en-US/docs/Web/CSS/rgb()">rgb()</a> (colors)</li>
	<li><a href="/en-US/docs/Web/CSS/rgba()">rgba()</a> (colors)</li>
	<li><a href="/en-US/docs/Web/CSS/transform-function/rotate()">rotate()</a> (transform)</li>
	<li><a href="/en-US/docs/Web/CSS/transform-function/rotate3d()">rotate3d()</a> (transform)</li>
	<li><a href="/en-US/docs/Web/CSS/transform-function/rotateX()">rotateX()</a> (transform)</li>
	<li><a href="/en-US/docs/Web/CSS/transform-function/rotateY()">rotateY()</a> (transform)</li>
	<li><a href="/en-US/docs/Web/CSS/transform-function/rotateZ()">rotateZ()</a> (transform)</li>
	<li><a href="/en-US/docs/Web/CSS/round()">round()</a> (math) {{Experimental_Inline}}</li>
</ul>

<h3>S</h3>

<ul>
	<li><a href="/en-US/docs/Web/CSS/filter-function/saturate()">saturate()</a> (filter)</li>
	<li><a href="/en-US/docs/Web/CSS/transform-function/scale()">scale()</a> (transform)</li>
	<li><a href="/en-US/docs/Web/CSS/transform-function/scale3d()">scale3d()</a> (transform)</li>
	<li><a href="/en-US/docs/Web/CSS/transform-function/scaleX()">scaleX()</a> (transform)</li>
	<li><a href="/en-US/docs/Web/CSS/transform-function/scaleY()">scaleY()</a> (transform)</li>
	<li><a href="/en-US/docs/Web/CSS/transform-function/scaleZ()">scaleZ()</a> (transform)</li>
	<li><a href="/en-US/docs/Web/CSS/filter-function/sepia()">sepia()</a> (filter)</li>
	<li><a href="/en-US/docs/Web/CSS/sign()">sign()</a> (math) {{Experimental_Inline}}</li>
	<li><a href="/en-US/docs/Web/CSS/sin()">sin()</a> (math) {{Experimental_Inline}}</li>
	<li><a href="/en-US/docs/Web/CSS/transform-function/skew()">skew()</a> (transform)</li>
	<li><a href="/en-US/docs/Web/CSS/transform-function/skewX()">skewX()</a> (transform)</li>
	<li><a href="/en-US/docs/Web/CSS/transform-function/skewY()">skewY()</a> (transform)</li>
	<li><a href="/en-US/docs/Web/CSS/sqrt()">sqrt()</a> (math) {{Experimental_Inline}}</li>
	<li><a href="/en-US/docs/Web/CSS/steps()">steps()</a></li>
	<li><a href="/en-US/docs/Web/CSS/font-variant-alternates/styleset()">styleset()</a> (font)</li>
	<li><a href="/en-US/docs/Web/CSS/font-variant-alternates/stylistic()">stylistic()</a> (font)</li>
	<li><a href="/en-US/docs/Web/CSS/font-variant-alternates/swash()">swash()</a> (font)</li>
	<li><a href="/en-US/docs/Web/CSS/symbols()">symbols()</a></li>
</ul>

<h3>T</h3>

<ul>
	<li><a href="/en-US/docs/Web/CSS/tan()">tan()</a> (math) {{Experimental_Inline}}</li>
	<li><a href="/en-US/docs/Web/CSS/target-counter()">target-counter()</a> {{Experimental_Inline}}</li>
	<li><a href="/en-US/docs/Web/CSS/target-counters()">target-counters()</a> {{Experimental_Inline}}</li>
	<li><a href="/en-US/docs/Web/CSS/target-text()">target-text()</a> {{Experimental_Inline}}</li>
	<li><a href="/en-US/docs/Web/CSS/toggle()">toggle()</a> {{Experimental_Inline}}</li>
	<li><a href="/en-US/docs/Web/CSS/transform-function/translate()">translate()</a> (transform)</li>
	<li><a href="/en-US/docs/Web/CSS/transform-function/translate3d()">translate3d()</a> (transform)</li>
	<li><a href="/en-US/docs/Web/CSS/transform-function/translateX()">translateX()</a> (transform)</li>
	<li><a href="/en-US/docs/Web/CSS/transform-function/translateY()">translateY()</a> (transform)</li>
	<li><a href="/en-US/docs/Web/CSS/transform-function/translateZ()">translateZ()</a> (transform)</li>
</ul>

<h3>U</h3>

<ul>
	<li><a href="/en-US/docs/Web/CSS/url()">url()</a></li>
</ul>

<h3>V</h3>

<ul>
	<li><a href="/en-US/docs/Web/CSS/var()">var()</a></li>
</ul>

</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName("CSS4 Values")}}</td>
			<td>{{Spec2("CSS4 Values")}}</td>
			<td>Adds <code>toggle()</code>, <code>attr()</code>, <code>calc()</code>, <code>min()</code>, <code>max()</code>, <code>clamp()</code>, <code>round()</code>, <code>mod()</code>, <code>rem()</code>, <code>mod()</code>, <code>sin()</code>, <code>cos()</code>, <code>tan()</code>, <code>asin()</code>, <code>acos()</code>, <code>atan()</code>, <code>atan2()</code>, <code>pow()</code>, <code>sqrt()</code>, <code>hypot()</code>, <code>log()</code>, <code>exp()</code>, <code>abs()</code> and <code>sign()</code> functional notation.</td>
		</tr>
		<tr>
			<td>{{SpecName("CSS3 Values")}}</td>
			<td>{{Spec2("CSS3 Values")}}</td>
			<td>Adds <code>calc()</code> functional notation.</td>
		</tr>
		<tr>
			<td>{{SpecName("CSS4 Colors")}}</td>
			<td>{{Spec2("CSS4 Colors")}}</td>
			<td>Adds commaless syntaxes for the <code>rgb()</code>, <code>rgba()</code>, <code>hsl()</code>, and <code>hsla()</code> functional notation.<br>
			Allows alpha values in <code>rgb()</code> and <code>hsl()</code>, turning <code>rgba()</code> and <code>hsla()</code> into (deprecated) aliases for them.<br>
			Adds <code>hwb()</code>, <code>device-cmyk()</code>, and <code>color()</code> functions.</td>
		</tr>
		<tr>
			<td>{{SpecName("CSS3 Colors")}}</td>
			<td>{{Spec2("CSS3 Colors")}}</td>
			<td>Adds <code>rgba()</code>, <code>hsl()</code>, <code>hsla()</code> functional notation.</td>
		</tr>
		<tr>
			<td>{{SpecName("CSS4 Images")}}</td>
			<td>{{Spec2("CSS4 Images")}}</td>
			<td>Adds <code>element()</code>, <code>image()</code>, <code>image-set()</code> and <code>conic-gradient()</code> functional notation.</td>
		</tr>
	</tbody>
</table>

<h2 id="See_also">See also</h2>

<ul>
	<li><a href="/en-US/docs/Web/CSS/CSS_Values_and_Units">CSS Values and Units</a></li>
	<li><a href="/en-US/docs/Learn/CSS/Introduction_to_CSS/Values_and_units">Introduction to CSS: Values and Units </a></li>
</ul>
